-module(gmhc_connectors_sup).
-behavior(supervisor).

-export([ start_link/0
        , init/1 ]).

-export([ start_first_connector/0
        , start_connector/1]).

start_link() ->
    supervisor:start_link({local, ?MODULE}, ?MODULE, []).

start_first_connector() ->
    start_connector(#{}).

start_connector(Opts0) ->
    Opts = case maps:is_key(id, Opts0) of
               true  -> Opts0;
               false -> Opts0#{id => gmhc_counters:add_read(connector)}
           end,
    supervisor:start_child(?MODULE, [Opts]).

init([]) ->
    Mod = gmhc_connector,
    SupFlags = #{ strategy => simple_one_for_one
                , intensity => 3
                , period => 10 },
    ChildSpecs = [ #{ id => Mod
                    , start => {Mod, start_link, []}
                    , type => worker
                    , restart => transient
                    , shutdown => 5000
                    , modules => [Mod] } ],
    {ok, {SupFlags, ChildSpecs}}.
